/* -*- Mode: C; tab-width: 4 -*-
 *
 * Copyright (c) 2002-2004 Apple Computer, Inc. All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/*
 *   Copyright (C) 2012 by Alive vision Software KK.
 *
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂́C
 *  {\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 */

#include <string.h>

#include <t_services.h>
#include "kernel_id.h"
#include "tinet_id.h"

#include <tinet_defs.h>
#include <tinet_config.h>

#include <net/net.h>
#include <net/net_var.h>
#include <net/net_timer.h>

#include <netinet/in.h>
#include <netinet/in_itron.h>
#include <netinet/tcp.h>

#include <netapp/netapp.h>
#include <netapp/netapp_var.h>
//#include <netapp/echo.h>

#include <assert.h>
#include <signal.h>
#include <stdio.h>			// For printf()
#include <stdlib.h>			// For exit() etc.
#include <string.h>			// For strlen() etc.
#include <unistd.h>			// For select()
#include <errno.h>			// For errno, EINTR
#include <netinet/in.h>		// For INADDR_NONE
//#include <arpa/inet.h>		// For inet_addr()
//#include <netdb.h>			// For gethostbyname()
#include <signal.h>			// For SIGINT, etc.

#include "mDNSEmbeddedAPI.h"  // Defines the interface to the client layer above
#include "mDNSitron.h"      // Defines the specific types needed to run mDNS on this platform
#include "mDNSsample.h"
#include "dns_sd.h"
#include "dnssd_clientshim.h"

// Globals
mDNS mDNSStorage;       // mDNS core uses this to store its globals
static mDNS_PlatformSupport PlatformStorage;  // Stores this platform's globals
#define RR_CACHE_SIZE 500
static CacheEntity gRRCache[RR_CACHE_SIZE];

mDNSexport const char ProgramName[] = "mDNSClientPosix";

static const char *gProgramName = ProgramName;

extern x_data_struct  x_data;
extern void HandleSIG(int signal);

//static const char kDefaultServiceType[] = "_afpovertcp._tcp";
static const char kDefaultServiceType[] = "_airport._tcp";
static const char kDefaultDomain[]      = "local.";

static const char *gServiceType      = kDefaultServiceType;
static const char *gServiceDomain    = kDefaultDomain;
/*
 *  TCP Mobt@
 */

UB tcp_echo_srv_swbuf[TCP_ECHO_SRV_SWBUF_SIZE];
UB tcp_echo_srv_rwbuf[TCP_ECHO_SRV_RWBUF_SIZE];


/*
 *  mubLOR[̃R[obN֐
 */

ER
callback_nblk_tcp_echo_srv (ID cepid, FN fncd, VP p_parblk)
{}


//*******************************************************************************************
// Main

static volatile mDNSBool StopNow;

void HandleSIG(int signal)
	{
	(void)signal;	// Unused
	StopNow = mDNStrue;
	}

mDNSexport void ExampleClientEventLoop_ITRON(mDNS *const m)
{
static char recvdata[1300];
T_IPV6EP	dstaddr;


	while (!StopNow)
	{
		struct timeval timeout;
		int result;
		
		
		// 2. Set up the timeout.
		// This example client has no other work it needs to be doing,
		// so we set an effectively infinite timeout
		timeout.tv_sec = 0x3FFFFFFF;
		timeout.tv_usec = 0;

//		syslog(LOG_NOTICE,"mDNSPosixGetFDSet called LOOP Continue");
		// 3. Give the mDNSPosix layer a chance to add its information to the fd_set and timeout
		mDNSPosixGetFDSet(m, &timeout);	//M
		
		syslog(LOG_NOTICE,"RECV TMO= %d",mDNStimevalToTMO(&timeout));
		// 4.ubLOM
		result = mDNSPlatformRecvUDP(m,recvdata,1300,&dstaddr,mDNStimevalToTMO(&timeout));
		syslog(LOG_NOTICE, "[UDP RECVED:%d] ", result);
		if (result > 0)	
		{
			// 5. Call mDNSPosixProcessFDSet to let the mDNSPosix layer do its work
			mDNSPosixProcessFDSet(m,recvdata,result,&dstaddr);
		}
	}
}
void DNSSD_API qr_reply(DNSServiceRef sdref, const DNSServiceFlags flags, uint32_t ifIndex, DNSServiceErrorType errorCode,
	const char *fullname, uint16_t rrtype, uint16_t rrclass, uint16_t rdlen, const void *rdata, uint32_t ttl, void *context)
{
    mStatus     status;
	char *op = (flags & kDNSServiceFlagsAdd) ? "Add" : "Rmv";
	const unsigned char *rd  = rdata;
	const unsigned char *end = (const unsigned char *) rdata + rdlen;
	char rdb[1000] = "", *p = rdb;
	int unknowntype = 0;

	(void)sdref;    // Unused
	(void)flags;    // Unused
	(void)ifIndex;  // Unused
	(void)ttl;      // Unused
	(void)context;  // Unused


	syslog(LOG_NOTICE,"[[qr_reply here!]]");

	if (!errorCode)
	{
		switch (rrtype)
		{
			case kDNSServiceType_AAAA:
				syslog(LOG_NOTICE,"AAAA==");
				syslog(LOG_NOTICE,"%02X%02X:%02X%02X:",
					rd[0x0], rd[0x1], rd[0x2], rd[0x3]);
				syslog(LOG_NOTICE,"%02X%02X:%02X%02X:",
					 rd[0x4], rd[0x5], rd[0x6], rd[0x7]);
				syslog(LOG_NOTICE,"%02X%02X:%02X%02X:",
					rd[0x8], rd[0x9], rd[0xA], rd[0xB]);
				syslog(LOG_NOTICE,"%02X%02X:%02X%02X:",
					 rd[0xC], rd[0xD], rd[0xE], rd[0xF]);
				break;
			default :
				syslog(LOG_NOTICE,"qr_reply: type = %d",rrtype);

		}
	}

	syslog(LOG_NOTICE,"fullname=%s type=%4d rrclass=%4d ",  fullname, rrtype, rrclass);
	if (errorCode)
	{
		if (errorCode == kDNSServiceErr_NoSuchRecord) syslog(LOG_NOTICE,"No Such Record");
		else if (errorCode == kDNSServiceErr_Timeout)
		{
			syslog(LOG_NOTICE,"No Such Record\n");
			syslog(LOG_NOTICE,"Query Timed Out\n");
			return;
		}
	}
	// Stop Query
	status = mDNS_StopQuery(&mDNSStorage, &x_data.QueryRecord.q);
    if (status != mStatus_NoError) 
    {
		syslog(LOG_NOTICE,"qr_reply: mDNS_StopQuery err=%d",status);
	}
	// exit event loop 
	HandleSIG(0);
}

static void ShowTXTRecord(uint16_t txtLen, const unsigned char *txtRecord)
{
	syslog(LOG_NOTICE,"[[ShowTXTRecord]]txtRecord = %s",txtRecord);
}


void DNSSD_API resolve_reply(DNSServiceRef sdref, const DNSServiceFlags flags, uint32_t ifIndex, DNSServiceErrorType errorCode,
	const char *fullname, const char *hosttarget, uint16_t opaqueport, uint16_t txtLen, const unsigned char *txtRecord, void *context)
{
	union { uint16_t s; u_char b[2]; } port = { opaqueport };
	uint16_t PortAsNumber = ((uint16_t)port.b[0]) << 8 | port.b[1];
    mStatus     status;

	(void)sdref;        // Unused
	(void)ifIndex;      // Unused
	(void)context;      // Unused

	syslog(LOG_NOTICE,"[[resolve_reply]]");
	if (errorCode)
	{
		syslog(LOG_NOTICE,"Error code %d\n", errorCode);
	}
	else
	{
		syslog(LOG_NOTICE,"fullname=%s can be reached at hosttarget=%s:port=%d", fullname, hosttarget, PortAsNumber );
		if (flags) 
		{
			syslog(LOG_NOTICE," Flags: %X", flags);
		}
		// Don't show degenerate TXT records containing nothing but a single empty string
		if (txtLen > 1) 
		{ 
			ShowTXTRecord(txtLen, txtRecord); 
		}
	}
	status = mDNS_StopQuery(&mDNSStorage, &x_data.Resolve.qSRV);
    if (status != mStatus_NoError) 
    {
		syslog(LOG_NOTICE,"resolve_reply: mDNS_StopBrowse qSRV err=%d",status);
	}
	status = mDNS_StopQuery(&mDNSStorage, &x_data.Resolve.qTXT);
    if (status != mStatus_NoError) 
    {
		syslog(LOG_NOTICE,"resolve_reply: mDNS_StopBrowse qTXT err=%d",status);
	}

	status = DNSServiceQueryRecord(  0, 0, hosttarget, kDNSServiceType_AAAA, kDNSServiceClass_IN, qr_reply, NULL );
    if (status != mStatus_NoError) 
    {
		syslog(LOG_NOTICE,"resolve_reply: DNSServiceQueryRecord err=%d",status);
	}
}

void DNSSD_API browse_reply( const DNSServiceFlags flags, uint32_t ifIndex, DNSServiceErrorType errorCode,
	const char *replyName, const char *replyType, const char *replyDomain, void *context)
{
    mStatus     status;
	char *op = (flags & kDNSServiceFlagsAdd) ? "Add" : "Rmv";
	(void)context;      // Unused

	syslog(LOG_NOTICE,"[[browse_reply Here!!]]");
	if (errorCode) syslog(LOG_NOTICE,"Error code %d\n", errorCode);
	else syslog(LOG_NOTICE,"%s flags=%XH domain=%s type=%s name= %s\n", op, flags,  replyDomain, replyType, replyName);

	status = mDNS_StopBrowse(&mDNSStorage, &x_data.browse.q);
    if (status != mStatus_NoError) 
    {
		syslog(LOG_NOTICE,"browse_reply: mDNS_StopBrowse err=%d",status);
	}
	status = DNSServiceResolve(replyName,replyType,replyDomain,resolve_reply,NULL);
    if (status != mStatus_NoError) 
    {
		syslog(LOG_NOTICE,"browse_reply: DNSServiceResolve err=%d",status);
	}
}

static void BrowseCallback(mDNS *const m, DNSQuestion *question, const ResourceRecord *const answer, QC_result AddRecord)
    // A callback from the core mDNS code that indicates that we've received a 
    // response to our query.  Note that this code runs on the main thread 
    // (in fact, there is only one thread!), so we can safely printf the results.
{
    domainlabel name;
    domainname  type;
    domainname  domain;
	char nameC  [MAX_DOMAIN_LABEL+1];			// Unescaped name: up to 63 bytes plus C-string terminating NULL.
	char typeC  [MAX_ESCAPED_DOMAIN_NAME];
	char domainC[MAX_ESCAPED_DOMAIN_NAME];
    const char *state;

	(void)m;		// Unused
	(void)question;	// Unused

	syslog(LOG_NOTICE, "[BrowseCallback Here!!] ");

//    assert(answer->rrtype == kDNSType_PTR);

    DeconstructServiceName(&answer->rdata->u.name, &name, &type, &domain);

    ConvertDomainLabelToCString_unescaped(&name, nameC);
    ConvertDomainNameToCString(&type, typeC);
    ConvertDomainNameToCString(&domain, domainC);

    // If the TTL has hit 0, the service is no longer available.
    if (!AddRecord) {
        state = "Lost ";
    } else {
        state = "Found";
    }
//    fprintf(stderr, "*** %s name = '%s', type = '%s', domain = '%s'\n", state, nameC, typeC, domainC);
	syslog(LOG_NOTICE, "state = %xH name = %s type = %s domain = %s", state, nameC, typeC, domainC);

}



void  mDNS_main(VP_INT exinf)
    // The program's main entry point.  The program does a trivial 
    // mDNS query, looking for all AFP servers in the local domain.
{
    int     result;
    mStatus     status;
    DNSQuestion question;
    domainname  type;
    domainname  domain;


	dly_tsk(1500);	// IPAhX܂܂ŁA҂
//	slp_tsk();		//tinet́@nd6_nbr.c wakeupBAhX肷܂ő҂
    // Initialise the mDNS core.
	status = mDNS_Init(&mDNSStorage, &PlatformStorage,
    	gRRCache, RR_CACHE_SIZE,
    	mDNS_Init_DontAdvertiseLocalAddresses,
    	mDNS_Init_NoInitCallback, mDNS_Init_NoInitCallbackContext);
    if (status == mStatus_NoError) {
    
        // Construct and start the query.
        
        MakeDomainNameFromDNSNameString(&type, gServiceType);
        MakeDomainNameFromDNSNameString(&domain, gServiceDomain);

// ǂł\@DNSServiceBrowse̕ʂ̊֐
//        status = mDNS_StartBrowse(&mDNSStorage, &question, &type, &domain, mDNSInterface_Any, mDNSfalse, BrowseCallback, NULL);
		status = DNSServiceBrowse(0,  gServiceType, gServiceDomain, browse_reply, NULL);
    
        // Run the platform main event loop until the user types ^C. 
        // The BrowseCallback routine is responsible for printing 
        // any results that we find.
        
        if (status == mStatus_NoError) {
        	ExampleClientEventLoop_ITRON(&mDNSStorage);
			mDNS_Close(&mDNSStorage);
        }
    }
    
	syslog(LOG_NOTICE,"mDNS_main: Fin");

}
